// battle code //
local battle_loaded = false

// -- perish song AOE --//
	local s_closestdist
	local s_closestmo
	local s_sourceplayer
local function PerishFindTarget(pmobj, mo)
	
	// only cures players and enimes
	if mo.type != MT_PLAYER then
		if mo.flags & (MF_ENEMY|MF_BOSS) then else // curse enemys and bosses too!
		return end
	end
	
	if mo.type == MT_PLAYER then // enemys dont need these checks
		// only curse the user in co-op like gamemodes
		if pmobj.target != mo and (gametyperules & GTR_FRIENDLY) then
		return end
		
		local singingplayer = pmobj.target.player
		// dont curse team mates unless friendly fire is on
		if pmobj.target != mo and (mo.player.ctfteam == singingplayer.ctfteam and
		(gametyperules & GTR_TEAMS) and not (gametyperules &GTR_FRIENDLYFIRE)and not CV_FindVar("friendlyfire").value) then
		return end
		
	end
	
	if mo.perishsongsource == nil or mo.perishsongsource != pmobj then // reset the curse inflicting if not the same source
		mo.perishcount = 0
		mo.perishsongsource = pmobj
		mo.perishactive = false
	end
	
	if mo.flags & (MF_NOCLIPTHING|MF_NOCLIP)
	or not mo.health or mo == pmobj
	or ((twodlevel or pmobj.flags2 & MF2_TWOD) and abs(pmobj.y-mo.y) > pmobj.radius)
	return end
				
	if pmobj.z-568*mo.scale > mo.z or pmobj.z+568*mo.scale < mo.z // check height
	return end
	
	if mo.perishcount == nil then
		mo.perishcount = 0
	end
	
	if mo.perishcount > 2*TICRATE and not mo.perishactive then
		local pcurse = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PSONGCOUNT)
		pcurse.tracer = mo
		pcurse.scale = pmobj.scale
		mo.perishactive = true
		mo.perishactivesource = pmobj.target
		mo.perishcount = 8*TICRATE
	elseif mo.perishcount <= 2*TICRATE then
		mo.perishcount = $+1
		mo.perishactive = false
	end
	s_closestmo = mo
	s_closestdist = adist
end

rawset(_G, "LO_PerishSongForPlayers", function(mobj, player, dist)
	s_closestdist = dist+1
	s_closestmo = nil
	s_sourceplayer = player
	searchBlockmap("objects", PerishFindTarget, mobj, mobj.x-dist, mobj.x+dist, mobj.y-dist, mobj.y+dist)
	// Check if it was in range!
	if(s_closestmo and s_closestmo.valid)
		and(P_AproxDistance(P_AproxDistance(mobj.x-s_closestmo.x, mobj.y-s_closestmo.y), mobj.z-s_closestmo.z) > FixedMul(dist, mobj.scale))
		s_closestmo = nil	 // out of range
	end
	return s_closestmo
end)

// battle object hooks
addHook("MobjThinker", function(mo)
	if mo and mo.valid then
		if mo.target and mo.target.valid and mo.target.player.actionstate == 1 then
			local player = mo.target.player

			if mo.target.state == S_PLAY_PAIN then
				P_RemoveMobj(mo)
				return
			end
			
			local vertadd = mo.downswing
			local horadd = mo.forwardswing+ 10
			local sideadd = mo.sidemod
			A_CapeChase(mo, (vertadd * 65536)+0, (horadd * 65536)+sideadd)
			if mo and mo.valid and mo.target and mo.target.valid then // stop erroring
				mo.angle = R_PointToAngle2(mo.target.x, mo.target.y, mo.x, mo.y)+mo.angemod
			end
			if mo and mo.valid and player.actiontime and player.actiontime <= 2 then
				mo.frame = FF_PAPERSPRITE|FF_TRANS10|FF_FULLBRIGHT|A
			elseif mo and mo.valid and player.actiontime and player.actiontime <= 4 then
				mo.frame = FF_PAPERSPRITE|FF_TRANS10|FF_FULLBRIGHT|B
					if player.actiontime == 4 then //play sound
						S_StartSound(player.mo, sfx_rail1)
					end
			elseif mo and mo.valid and player.actiontime and player.actiontime <= 5 then // become active
				mo.frame = FF_PAPERSPRITE|FF_TRANS10|FF_FULLBRIGHT|C
				mo.activehitbox = true
				mo.forwardswing = 10
				mo.downswing = 0
			elseif mo and mo.valid and player.actiontime and player.actiontime <= 7 then
				mo.frame = FF_PAPERSPRITE|FF_TRANS10|FF_FULLBRIGHT|D
			elseif mo and mo.valid and player.actiontime and player.actiontime <= 8 then
				mo.frame = FF_PAPERSPRITE|FF_TRANS10|FF_FULLBRIGHT|E
				mo.forwardswing = 5
				mo.downswing = -1
			elseif mo and mo.valid and player.actiontime and player.actiontime <= 10 then // lose active
				mo.frame = FF_PAPERSPRITE|FF_TRANS10|FF_FULLBRIGHT|F
				mo.activehitbox = false
				mo.forwardswing = -5
				mo.downswing = -1
			elseif mo and mo.valid and player.actiontime and player.actiontime <= 12 then
				mo.frame = FF_PAPERSPRITE|FF_TRANS50|FF_FULLBRIGHT|F
			elseif mo and mo.valid and player.actiontime and player.actiontime <= 14 then
				mo.frame = FF_PAPERSPRITE|FF_TRANS80|FF_SEMIBRIGHT|F
			end
		else
			P_RemoveMobj(mo)
			return
		end
	end
end, MT_SHADOWCLAW)//-------------------------------//

addHook("MobjThinker", function(mo)
	
	local vertadd = 42
	if mo.target and mo.target.valid then
		local player = mo.target.player
		local halftic = TICRATE/2
		if player.actiontime <= TICRATE*2 and player.actiontime > 0 then
			vertadd = 82 - player.actiontime/2 
			mo.horadd = 96 + player.actiontime 
			if (mo.eflags&MFE_VERTICALFLIP) then
				vertadd = $*-1
			end
		end
		
		local gravityflip = false
		if (mo.eflags&MFE_VERTICALFLIP) then
			gravityflip = true
		end
		
		if mo.falltime and mo.falltime > TICRATE*2 then
			P_RemoveMobj(mo)
			return
		end
		
		if mo.frameseter == 1 then
			mo.frame = FF_TRANS10|FF_FULLBRIGHT|A
		elseif mo.frameseter == 2 then
			mo.frame = FF_TRANS10|FF_FULLBRIGHT|B
		elseif mo.frameseter == 3 then
			mo.frame = FF_TRANS10|FF_FULLBRIGHT|C
		elseif mo.frameseter == 4 then
			mo.frame = FF_TRANS10|FF_FULLBRIGHT|D
		end
		
		local fallnow = false
		if (mo.flags&MF_NOGRAVITY) then
		  fallnow = true
		end
		
		if mo.target.state != S_PLAY_PSONG and not mo.notefall then
			P_RemoveMobj(mo)
		end
		
		if (player.actiontime > TICRATE*2 or player.actionstate != 2) and 
		((gravityflip == false and mo.rollangle >= 0)or(gravityflip == true and mo.rollangle <= 0) ) and
		mo.target and mo.target.valid  and fallnow == true then //and mo.rollangle < ANGLE_180
			vertadd = 42
			if gravityflip == true then
				vertadd = $*-1
				mo.rollangle = $-ANG15
			else
				mo.rollangle = $+ANG15
			end

			mo.color = SKINCOLOR_GREY
			mo.momz = 0
			mo.notefall = true
			if (mo.rollangle < 0 and gravityflip == false) or  (mo.rollangle > 0 and gravityflip == true)then
					mo.rollangle = ANGLE_180
					mo.flags = $&~MF_NOCLIPHEIGHT 
					mo.flags = $&~MF_NOGRAVITY //fall on ground
			end
		end
		
		if mo and mo.valid and not mo.notefall then
			local horadd = mo.horadd
			A_Custom3DRotate (mo,(vertadd*(65536))+horadd,(50*(65536))+0)
			if player.actionstate != 2 then
				P_RemoveMobj(mo)
				return
			end
		elseif mo and mo.valid then 
			mo.falltime = $+1
		end
	end

end, MT_PSONGNOTE)//-------------------------------//

addHook("MobjThinker", function(mo)
 if mo.target and mo.target.valid then
	local player = mo.target.player
	mo.tracer = LO_PerishSongForPlayers(mo, player, 1135*mo.scale) // start to curse everyone in range
	P_SetOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	if player.actionstate != 2 or mo.target.state == S_PLAY_DEAD or mo.target.state == S_PLAY_DRWN then
		P_RemoveMobj(mo)
		return
	end
	
 else
	P_RemoveMobj(mo)
	return
 end
end, MT_PSONSOURCE)//-------------------------------//

addHook("MobjThinker", function(mo)
 if mo.tracer and mo.tracer.valid and mo.tracer.perishactive and mo.tracer.perishcount >= 0
	and (mo.tracer.state != S_PLAY_DEAD or mo.tracer.state != S_PLAY_DRWN) then
	local player = mo.tracer.player
	local perishdistance = R_PointToDist2(mo.x, mo.y, mo.tracer.x, mo.tracer.y)
	local perishangle = R_PointToAngle2(mo.x, mo.y, mo.tracer.x, mo.tracer.y)
	
	
	local xdistance = mo.x
	local ydistance = mo.y
	local zdistance = mo.z
	local tracherheight = (mo.tracer.z - mo.z)*2
	// draw the line between the source and the player
	// 13 objects
	if mo.tracer.type == MT_PLAYER then
		for i = 0, 4 do
			//print(mo.tracer.z+mo.z)
			if i == 0 then
			xdistance = mo.x
			ydistance = mo.y
			zdistance = mo.z
			elseif i == 1 then
			xdistance = mo.x+FixedMul(perishdistance/4, cos(perishangle))
			ydistance = mo.y+FixedMul(perishdistance/4, sin(perishangle))
			zdistance = mo.z+(tracherheight/5)
			elseif i == 2 then // half way
			xdistance = mo.x+FixedMul(perishdistance/2, cos(perishangle))
			ydistance = mo.y+FixedMul(perishdistance/2, sin(perishangle))
			zdistance = mo.z+(tracherheight/3)
			elseif i == 3 then
			xdistance = mo.x+FixedMul(perishdistance/4*3, cos(perishangle))
			ydistance = mo.y+FixedMul(perishdistance/4*3, sin(perishangle))
			zdistance = mo.tracer.z-(tracherheight/12) //8
			elseif i == 4 then
			xdistance = mo.x+FixedMul(perishdistance/10*9, cos(perishangle))
			ydistance = mo.y+FixedMul(perishdistance/10*9, sin(perishangle))
			zdistance = mo.tracer.z-(tracherheight/24) //16
			end
			local drawskull = P_SpawnMobj(xdistance, ydistance, zdistance+(mo.tracer.height/2), MT_PSONGLINE)
			drawskull.tracer = mo.tracer
			drawskull.scale = mo.scale
			
			if mo.tracer.player != displayplayer then
				drawskull.flags2 = $ | MF2_DONTDRAW
			end
			
			if i >= 4 then
			break
			end
		end
	elseif mo.tracer.flags & (MF_ENEMY|MF_BOSS) then
			local drawskull = P_SpawnMobj(mo.tracer.x, mo.tracer.y, mo.tracer.z+(mo.tracer.height), MT_PSONGLINE)
			//drawskull.tracer = mo.tracer
			drawskull.scale = mo.scale
	end
	// if far away break the curse
	if perishdistance > 1735*mo.scale or mo.z-968*mo.scale > mo.tracer.z or mo.z+968*mo.scale < mo.tracer.z then
		mo.tracer.perishcount = 0
		mo.tracer.perishactive = false
		if mo.tracer.type == MT_PLAYER then
			S_StartSound(mo.tracer, sfx_adderr, mo.tracer.player)
			player.powers[pw_spacetime] = 1073741824 
			if player.lightweakness != nil and player.lightweakness < TICRATE*2 then
				player.lightweakness = TICRATE*2
			end
		end
		P_RemoveMobj(mo)
		return
	end
	mo.tracer.perishcount = $-1
		if mo.tracer.type == MT_PLAYER then
			player.powers[pw_spacetime] = mo.tracer.perishcount
		elseif mo.tracer.perishcount <= 0 and mo.tracer.flags & (MF_ENEMY|MF_BOSS) then // hurt your self... NOW!
			P_DamageMobj(mo.tracer, mo.tracer, mo.tracer)
			mo.tracer.perishcount = 1
		end
	else
	P_RemoveMobj(mo)
	return
 end
end, MT_PSONGCOUNT)//-------------------------------//

// perish song kill score
addHook("MobjDeath",function(targ, inf, src, dmgType) // no player related things? hyudoro gets credit for it
  if targ and targ.valid and targ.player and targ.perishactive and targ.perishactivesource then
	if src and src.type == MT_PLAYER then
	return end
	if inf and inf.type == MT_PLAYER then
	return end
	local playerpush = targ.player
	if playerpush.pushed_creditplr and playerpush.pushed_creditplr.valid and (damagetype == DMG_DEATHPIT or damagetype == DMG_CRUSHED)
	and not(B.MyTeam(playerpush,playerpush.pushed_creditplr)) then
	return end
		local singingplayer = targ.perishactivesource.player
		if targ.perishactivesource != targ then 
			 if targ.player.ctfteam == singingplayer.ctfteam and (gametyperules & GTR_TEAMS) then 
			 else // dont gain points for killing teammates!
			P_AddPlayerScore(targ.perishactivesource.player, 100) 
			S_StartSound(nil, sfx_s249, targ.perishactivesource.player)
			end
		end
		targ.perishactivesource = 0
		targ.perishactive = false
  end
end,MT_PLAYER)

addHook("MobjThinker", function(mo)
	
	if mo.target and mo.target.valid and mo.target.state == S_PLAY_DBOND then
		A_RotateSpikeBall(mo,0,0)
		if mo.spawneffect > TICRATE/10 then
			local effect = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DESTINYPOFF)
			effect.momx = 0
			effect.momy = 0
			mo.spawneffect = 0
		end
		mo.spawneffect = $+1
	else
		P_RemoveMobj(mo)
	end

end, MT_DESTINYFLAME)//-------------------------------//

addHook("MobjThinker", function(mo) // too lazy to make a function
	
	if mo.target and mo.target.valid and mo.target.state == S_PLAY_DBOND then
		A_RotateSpikeBall(mo,0,0)
		if mo.spawneffect > TICRATE/10 then
			local effect = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DESTINYPOFF)
			effect.momx = 0
			effect.momy = 0
			mo.spawneffect = 0
		end
		mo.spawneffect = $+1
	else
		P_RemoveMobj(mo)
	end

end, MT_DESTINYFLAME2)//-------------------------------//

addHook("MobjDeath", function(mo, inflictor, source, damagetype) // ---- when dying durring destiny bond take the killer with you!
	if mo.skin !="hyudoro" then
		return
	end
	if mo.player and mo.player.valid and mo.player.actionstate == 3 and inflictor and inflictor.valid then
		local destanybondrevenge = false // find the killer
		mo.player.actionstate = 0
			if source and source.valid then // try to kill source
				if source.flags & (MF_ENEMY|MF_BOSS) or source.type == MT_PLAYER then 
				else return // no you cannot kill the glaregoils!
				end
				if source == mo then // dont kill yourself twice!
					return
				end
				destanybondrevenge = source // found the killer

		elseif inflictor and inflictor.valid then // kill inflictor instead
				if inflictor.flags & (MF_ENEMY|MF_BOSS) or inflictor.type == MT_PLAYER then 
				else return // dont kill projectiles?
				end
				if inflictor == mo then
					return
				end
				destanybondrevenge = inflictor // found the killer!
		end
		if destanybondrevenge and destanybondrevenge.valid and destanybondrevenge.health then
			local destanybond = P_SpawnMobj(destanybondrevenge.x, destanybondrevenge.y, destanybondrevenge.z, MT_DESTINYSHADOW)
			destanybond.tracer = destanybondrevenge
			destanybond.creator = mo
			destanybond.revengeheight = 0
			destanybond.scale = destanybondrevenge.scale
			if destanybondrevenge.flags2 & MF2_OBJECTFLIP then
				destanybond.flags2 = $|MF2_OBJECTFLIP // flip with the target
			end
			if destanybondrevenge.player and destanybondrevenge.player.valid then
				S_StartSound(destanybondrevenge, sfx_timeup, destanybondrevenge.player)
			end
		end
	end
end, MT_PLAYER) //---------------------------//

addHook("MobjThinker", function(mo)
	if mo.tracer and mo.tracer.valid and mo.tracer.health then// theres a smarter way to do this but im too lazzy
		if mo.tracer.flags2 & MF2_OBJECTFLIP then //---------------- reverse gravity-----------------//
			mo.destscale = mo.tracer.shadowscale*2
			local shadowheight = P_CeilingzAtPos(mo.tracer.x, mo.tracer.y, mo.tracer.z, mo.tracer.height)
			A_CapeChase(mo, (0 * 65536)+1, (0 * 65536)+0)
			mo.z = shadowheight
			// follow there shadow check gravity later
			if mo.target == nil then // make the hand effect below the shadow
				mo.target = P_SpawnMobjFromMobj(mo, 0, 0, 20*mo.scale, MT_DESTINYSHADOWHAND)
				mo.target.destscale = FRACUNIT
				mo.target.tracer = mo
				local zdiff = mo.tracer.z-mo.target.z
				mo.target.momz = zdiff/16 // start with speed
			elseif not mo.handinrange then// reach hand out to the tracer
				P_SetOrigin(mo.target, mo.x, mo.y, mo.target.z)
				A_ZThrust(mo.target, 1, (1<<0)+0)
			end
			if mo.target.z <= mo.tracer.z+(10*FRACUNIT) and not mo.handinrange then
				if mo.tracer.flags & (MF_ENEMY|MF_BOSS) then // damage for now
					P_DamageMobj(mo.tracer, mo, mo)
					mo.target.z = mo.tracer.z
					mo.target.frame = FF_TRANS10|FF_FULLBRIGHT|B // close hand
					mo.target.momz = 0
				end
				if mo.tracer.type == MT_PLAYER then 
					mo.handinrange = true
					mo.target.momz = 0
					mo.tracer.state = S_PLAY_PAIN 
					mo.target.z = mo.tracer.z
					A_ZThrust(mo.target, 20, (1<<0)+0)
					A_ZThrust(mo.tracer, 20, (1<<0)+0)
					mo.target.frame = FF_TRANS10|FF_FULLBRIGHT|B // close hand
				end
			end
			if mo.handinrange and mo.tracer.type == MT_PLAYER then // drag player to you
				A_ZThrust(mo.target, -5, (1<<0)+0)
				mo.tracer.momx = 0
				mo.tracer.momy = 0
				mo.tracer.momz = 0
				P_SetOrigin(mo.tracer, mo.target.x, mo.target.y, mo.target.z)
				if mo.tracer.z >= mo.z then // at shadow kill them
					P_DamageMobj(mo.tracer, mo, mo, 1, DMG_INSTAKILL)
					A_ZThrust(mo.tracer, -30, (1<<1)+1)
					mo.tracer.health = 0 // just in case
				end
			end
			local handtoshadow = mo.target.z-mo.z
			// add segment?
				if mo.z > mo.target.z then
					local handsegment = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DESTINYSHADOWHANDSEG)
					handsegment.destscale = FRACUNIT
					handsegment.spriteyscale = handtoshadow/-19
				end
		else //------------------ normal gravity --------------------------------//
			mo.destscale = mo.tracer.shadowscale*2
			local shadowheight = P_FloorzAtPos(mo.tracer.x, mo.tracer.y, mo.tracer.z, mo.tracer.height)
			A_CapeChase(mo, (0 * 65536)+1, (0 * 65536)+0)
			mo.z = shadowheight
			// follow there shadow check gravity later
			if mo.target == nil then // make the hand effect below the shadow
				mo.target = P_SpawnMobjFromMobj(mo, 0, 0, -20*mo.scale, MT_DESTINYSHADOWHAND)
				mo.target.destscale = FRACUNIT
				mo.target.tracer = mo
				local zdiff = mo.tracer.z-mo.target.z
				mo.target.momz = zdiff/16 // start with speed
			elseif not mo.handinrange then// reach hand out to the tracer
				P_SetOrigin(mo.target, mo.x, mo.y, mo.target.z)
				A_ZThrust(mo.target, 1, (1<<0)+0)
			end
			if mo.target.z >= mo.tracer.z-(10*FRACUNIT) and not mo.handinrange then
				if mo.tracer.flags & (MF_ENEMY|MF_BOSS) then // damage for now
					P_DamageMobj(mo.tracer, mo, mo.creator)
					mo.target.z = mo.tracer.z
					mo.target.frame = FF_TRANS10|FF_FULLBRIGHT|B // close hand
					mo.target.momz = 0
				end
				if mo.tracer.type == MT_PLAYER then 
					mo.handinrange = true
					mo.target.momz = 0
					mo.tracer.state = S_PLAY_PAIN 
					mo.target.z = mo.tracer.z
					A_ZThrust(mo.target, 20, (1<<0)+0)
					A_ZThrust(mo.tracer, 20, (1<<0)+0)
					mo.target.frame = FF_TRANS10|FF_FULLBRIGHT|B // close hand
				end
			end
			if mo.handinrange and mo.tracer.type == MT_PLAYER then // drag player to you
				A_ZThrust(mo.target, -5, (1<<0)+0)
				mo.tracer.momx = 0
				mo.tracer.momy = 0
				mo.tracer.momz = 0
				P_SetOrigin(mo.tracer, mo.target.x, mo.target.y, mo.target.z)
				if mo.tracer.z <= mo.z then // at shadow kill them
					P_DamageMobj(mo.tracer, mo, mo.creator, 1, DMG_INSTAKILL)
					A_ZThrust(mo.tracer, -30, (1<<1)+1)
					mo.tracer.health = 0 // just in case
				end
			end
			local handtoshadow = mo.target.z-mo.z
			// add segment?
				if mo.z < mo.target.z then
					local handsegment = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DESTINYSHADOWHANDSEG)
					handsegment.destscale = FRACUNIT
					handsegment.spriteyscale = handtoshadow/19
				end
		end
	else
		P_RemoveMobj(mo)
	end
end, MT_DESTINYSHADOW) //---------------------------//

addHook("MobjThinker", function(mo)

	if mo.tracer and mo.tracer.valid then
	else
		P_RemoveMobj(mo)
	end
end, MT_DESTINYSHADOWHAND) //---------------------------//

local function ShadowClawCollide(boxhit, mobj)
local boxplayer = boxhit.target.player
local launchsped = FixedMul(mobj.scale, (3*FRACUNIT)/((mobj.eflags & MFE_UNDERWATER) and 2 or 1))
local bottomhit = boxhit.height/2
	if not boxhit.activehitbox then
	return end
	if ( boxhit.z-bottomhit < (mobj.z+mobj.height))
	and ((boxhit.z+boxhit.height) > mobj.z)
	and R_PointToAngle2(boxhit.x, boxhit.y, mobj.x, mobj.y)-boxhit.angle <= ANGLE_90 // dont hit behind you
		if (mobj.valid and mobj.health and mobj.flags & (MF_ENEMY|MF_BOSS))
			P_DamageMobj(mobj, boxhit.target, boxhit.target) // use targets attack
			if mobj.health > 0 then
				boxhit.target.momx = $/2 // slow down when you hit someone
				boxhit.target.momy = $/2
			end
		end
		if(mobj.valid and mobj.health and mobj.type == MT_PLAYER and mobj != boxhit.target and 
		(mobj.player.ctfteam != boxplayer.ctfteam or not (gametyperules & GTR_TEAMS) or (gametyperules &GTR_FRIENDLYFIRE) or CV_FindVar("friendlyfire").value) 
		and not mobj.player.powers[pw_flashing]
			and (mobj.type ~= MT_PLAYER or not (gametyperules & GTR_FRIENDLY) and gametype ~= GT_RACE and gametype ~= GT_COMPETITION))
			P_DamageMobj(mobj, boxhit.target, boxhit.target) // use targets attack
				if boxplayer.powers[pw_flashing] < 3
					boxplayer.powers[pw_flashing] = 3
				end
			if (mobj.player.guard != nil and mobj.player.guard < 1 and mobj.state != S_PLAY_DEAD)
				P_Thrust(mobj, boxhit.angle, launchsped)
				S_StartSound(mobj,sfx_hit02)
				boxhit.target.momx = $/2 // slow down when you hit someone
				boxhit.target.momy = $/2
				P_SetObjectMomZ(mobj, (launchsped), true)
			end
		end
		if (mobj.valid and mobj.health and mobj.flags & MF_MONITOR)
			P_KillMobj(mobj, boxhit, boxhit.target)
		end
	else
		return nil
	end
end

addHook("MobjMoveCollide", ShadowClawCollide, MT_SHADOWCLAW)
addHook("MobjCollide", ShadowClawCollide, MT_SHADOWCLAW)

addHook("ShouldDamage", function(mo, inflictor, source, damage, damagetype) // block projectiles
	
	if mo and mo.valid and mo.skin == "hyudoro" and inflictor and inflictor.valid and
	inflictor.flags & (MF_MISSILE) and (mo.state == S_PLAY_SCLAW1 or mo.state == S_PLAY_SCLAW2) and
	R_PointToAngle2(mo.x, mo.y, inflictor.x, inflictor.y)-mo.player.drawangle <= ANGLE_90 then 
	 P_KillMobj(inflictor, mo, mo.target)
	 S_StartSound(mo, sfx_turhit)
	 if inflictor and inflictor.valid then
		inflictor.flags = $|MF_NOCLIP|MF_NOCLIPTHING&~MF_SPECIAL&~MF_MISSILE
	 end
	 return false
	end
end, MT_PLAYER)

addHook("ThinkFrame", function()
	if battle_loaded or not CBW_Battle
		return
	end
	battle_loaded = true
	local B = CBW_Battle

	local GhostTypeMoves = function(mo, doaction)
			local player = mo.player
			local sludge = mo.eflags&MFE_GOOWATER
			local grounded = P_IsObjectOnGround(mo)
			local thrustpower = 8
			local thrustfactor = mo.scale
			local clawcooldown = TICRATE/3
			local psongcooldown = TICRATE*2
			local dbondcooldown = TICRATE*15
			local dbondtrigger = false
				player.actionrings = 10

			if P_IsObjectOnGround(mo)and player.rings <= 0 and (player.powers[pw_shield]) == 0 and
			player.cmd.forwardmove == 0 and player.cmd.sidemove == 0 then
				player.actiontext = "Destiny Bond"
				dbondtrigger = true
			elseif P_IsObjectOnGround(mo) and player.cmd.forwardmove == 0 and player.cmd.sidemove == 0 then
				player.actiontext = "Perish Song"
			else
				player.actiontext = "Shadow Claw"
			end
			player.action2text = nil
			
			//Action triggers
			local trigger_destinybond = (doaction == 1 and player.actionstate == 0 and grounded and
			player.cmd.forwardmove == 0 and player.cmd.sidemove == 0 and dbondtrigger)
			
			local trigger_perishsong = (doaction == 1 and player.actionstate == 0 and grounded and 
			player.cmd.forwardmove == 0 and player.cmd.sidemove == 0 and not dbondtrigger)
			
			local trigger_shadowclaw = (doaction == 1 and player.actionstate == 0 and
			(player.cmd.forwardmove != 0 or player.cmd.sidemove != 0 or not grounded))
			
			local trigger_gmoveexit = ((player.actiontime >= 16 and player.actionstate == 1)
			or (player.actiontime >= 3*TICRATE and player.actionstate == 2) or (player.actiontime >= 4*TICRATE and player.actionstate == 3))
			
			//Execute Shadow Claw//
		if trigger_shadowclaw
			if player.actionstate == 0 then
				B.PayRings(player)
			end
				if player.cmd.forwardmove >= 10 then
					player.thrustclaw = true
				else
					player.thrustclaw = false
				end
				player.fixspinbug = 0
				player.canguard = false
				player.actionstate = 1 //state_shadowclaw
				player.drawangle = mo.angle
				player.actiontime = 1
				player.canguard = 0
				if grounded then
					A_ZThrust(player.mo, 2, 0)
				end
				mo.state = S_PLAY_SCLAW1
				// spawn shadow claw hit box  // add two more later?
				for i = 0,2 do
					local claw1 = P_SpawnMobj(mo.x+FixedMul(1*FRACUNIT, cos(mo.angle)),  
						mo.y+FixedMul(1*FRACUNIT, sin(mo.angle)), mo.z, MT_SHADOWCLAW)
					claw1.target = mo
					claw1.scale = mo.scale
					claw1.angle = mo.angle
					claw1.forwardswing = 0
					claw1.downswing = 2
					claw1.sidemod = 0
					claw1.angemod = 0
					if i == 1 then
						claw1.sidemod = 8
						claw1.angemod = ANGLE_22h/2
					elseif i == 2 then
						claw1.sidemod = -8
						claw1.angemod = -ANGLE_22h/2
					end
					if i >= 2 then
					break
					end
				end
			return
		end 
		
		//Execute Perish Song//
		if trigger_perishsong
			if player.actionstate == 0 then
				B.PayRings(player)
			end
			player.fixspinbug = 0
			player.canguard = false
			player.actionstate = 2 // state_perishsong
			player.actiontime = 1
			player.lockmove = true
			mo.state = S_PLAY_PSONG
			player.pflags = $&~(PF_SPINNING|PF_SHIELDABILITY)
			local psource = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PSONSOURCE)
			psource.scale = mo.scale
			psource.target = mo
			S_StartSound(psource, sfx_psong)
				for i = 0, 11 do // spawn the music notes
				
				local xpos = 60*FRACUNIT
				local ypos = 60*FRACUNIT
				local frameset = 1
				if i == 0 then //
					 xpos = 60*FRACUNIT 
					 ypos = 60*FRACUNIT 
					 frameset = 1
				elseif i == 1 then
					 xpos = 25*FRACUNIT
					 ypos = 85*FRACUNIT 
					frameset = 2
				elseif i == 2 then
					 xpos = -25*FRACUNIT
					 ypos = 85*FRACUNIT
					 frameset = 2
				elseif i == 3 then //
					 xpos = -60*FRACUNIT
					 ypos = 60*FRACUNIT
					 frameset = 3
				elseif i == 4 then
					xpos = 85*FRACUNIT 
					ypos = 25*FRACUNIT 
					frameset = 3
				elseif i == 5 then
					xpos = -85*FRACUNIT 
					ypos = 25*FRACUNIT 
					 frameset = 1
				elseif i == 6 then //
					 xpos = 60*FRACUNIT
					 ypos = -60*FRACUNIT
					  frameset = 2
				elseif i == 7 then
					xpos = -85*FRACUNIT 
					ypos = -25*FRACUNIT 
					 frameset = 3
				elseif i == 8 then
					xpos = -25*FRACUNIT 
					ypos = -85*FRACUNIT 
					 frameset = 1
				elseif i == 9 then //
					 xpos = -60*FRACUNIT
					 ypos = -60*FRACUNIT
					  frameset = 3
				elseif i == 10 then 
					 xpos = 25*FRACUNIT
					 ypos = -85*FRACUNIT
					  frameset = 2
				elseif i == 11 then 
					 xpos = 85*FRACUNIT
					 ypos = -25*FRACUNIT
					  frameset = 4
				end
				
					//local pnote = P_SpawnMobj(mo.x+xpos, mo.y+ypos, mo.z+(mo.height), MT_PSONGNOTE)
					local pnote = P_SpawnMobjFromMobj(mo, xpos, ypos, mo.height, MT_PSONGNOTE)
					pnote.angle = R_PointToAngle2(pnote.x, pnote.y, mo.x, mo.y)
					pnote.target = mo
					if (gametyperules & GTR_TEAMS) then
						pnote.color = mo.color
					else
						pnote.color = SKINCOLOR_PINK
					end
					pnote.falltime = 1
					pnote.frameseter = frameset
					if i >= 11 then
					break
					end
				end
			return
		end
		
		// exacute destiny bond
		if trigger_destinybond then
			player.fixspinbug = 0
			player.canguard = false
			player.actionstate = 3 // state_destinybond
			player.actiontime = 1
			player.lockmove = true
			A_ZThrust(mo, 2, (1<<0)+1)
			mo.state = S_PLAY_DBOND
			player.pflags = $&~(PF_SPINNING|PF_SHIELDABILITY)
			S_StartSound(psource, sfx_dbond)
			// add effects 0 - 3
			for i = 0, 3 do // spawn the d bond effects
			
				local xpos = 20*FRACUNIT
				local ypos = 20*FRACUNIT
				if i >= 2 then
					 xpos = -20*FRACUNIT
					 ypos = -20*FRACUNIT
				end
				
				if i == 0 or i == 2 then
					local effect = P_SpawnMobj(mo.x+FixedMul(xpos, cos(mo.angle)),  
							mo.y+FixedMul(ypos, sin(mo.angle)), mo.z+(22*mo.scale), MT_DESTINYFLAME)
					effect.scale = mo.scale
					effect.angle = R_PointToAngle2(effect.x, effect.y, mo.x, mo.y)
					effect.target = mo
					effect.spawneffect = 1
				else
					local effect = P_SpawnMobj(mo.x+FixedMul(xpos, cos(mo.angle)),  
							mo.y+FixedMul(ypos, sin(mo.angle)), mo.z+(22*mo.scale), MT_DESTINYFLAME2)
					effect.scale = mo.scale
					effect.angle = R_PointToAngle2(effect.x, effect.y, mo.x, mo.y)
					effect.target = mo
					effect.spawneffect = 1
				end
				
				if i >= 3 then
						break
						end
				end
			return
		end
		
		if player.actionstate > 0 and mo.state == S_PLAY_PAIN then
			player.lockmove = false
			player.actiontime = 0
			B.ResetPlayerProperties(player,false,false)
			B.ApplyCooldown(player,clawcooldown)
			return
		end
		
		if player.actionstate == 3 then
			if player.actiontime == TICRATE or player.actiontime == TICRATE*2 
			or  player.actiontime == TICRATE*3 then
				S_StartSound(psource, sfx_dbond)
			end

			player.canguard = false
			//Speed Cap
			local speed = FixedHypot(mo.momx,mo.momy)
			if speed > mo.scale then
				local dir = R_PointToAngle2(0,0,mo.momx,mo.momy)
				P_InstaThrust(mo,dir,FixedMul(speed,mo.friction))
			end
			player.lockaim = true
			mo.momz = 0
			player.pflags = $&~(PF_SPINNING|PF_SHIELDABILITY)
			if mo.state == S_PLAY_PAIN then
				B.ApplyCooldown(player,dbondcooldown) // if not d bonding reset stuff
					B.ResetPlayerProperties(player,false,false)
					player.lockmove = false
					player.actionstate = 0
					return
			end
			mo.state = S_PLAY_DBOND
			mo.frame = 6
		end
		
		if player.actionstate == 2 then
			player.canguard = false
			player.lockmove = true
			player.lockaim = true
			player.pflags = $&~(PF_SPINNING|PF_SHIELDABILITY)
			if mo.state == S_PLAY_PAIN then
				B.ApplyCooldown(player,psongcooldown) // if not singing reset stuff
					B.ResetPlayerProperties(player,false,false)
					player.lockmove = false
					player.actionstate = 0
					return
			end
			mo.state = S_PLAY_PSONG
		end
		
		if player.actionstate == 1 //state_shadowclaw then
			player.lockmove = true
			player.pflags = $&~(PF_SPINNING|PF_SHIELDABILITY) 
				if mo.state > S_PLAY_PAIN and mo.state != S_PLAY_SCLAW1 and mo.state != S_PLAY_SCLAW2 and mo.state != S_PLAY_SCLAW3
				and mo.state != S_PLAY_JUMP and mo.state != S_PLAY_FALL and mo.state != S_PLAY_ROLL then
					B.ApplyCooldown(player,clawcooldown) // you got hit by something?
					B.ResetPlayerProperties(player,false,false)
					player.lockmove = false
					player.actionstate = 0
					return
				end
				if player.actiontime <= 3 and mo.state != S_PLAY_PAIN then 
					player.drawangle = mo.angle // make it a few frames to set the angle
					mo.state = S_PLAY_SCLAW1
					mo.frame = 0
				elseif player.actiontime <= 7 and mo.state != S_PLAY_PAIN then 
					mo.state = S_PLAY_SCLAW2
					mo.frame = 1
					if player.thrustclaw and player.actiontime == 4 then
						// dash forward a bit
						P_Thrust(mo,player.drawangle,thrustfactor*thrustpower)
					end
				elseif mo.state != S_PLAY_PAIN then
					mo.state = S_PLAY_SCLAW3
					mo.frame = 2
				end
		end
		
		//Timers
		if player.actiontime > 0 then
			player.actiontime = $+1
		end	
		
		//End battle moves
		if trigger_gmoveexit then
			//Apply cooldowns
			if player.actionstate == 3 then
				B.ApplyCooldown(player,dbondcooldown)
				player.actionstate = 0
			elseif player.actionstate == 2 then
				B.ApplyCooldown(player,psongcooldown)
				player.actionstate = 0
			elseif player.actionstate == 1 then
				B.ApplyCooldown(player,clawcooldown)
				player.actionstate = 0
			end
			player.lockmove = false
			player.actiontime = 0
			B.ResetPlayerProperties(player,false,false)
			mo.state = S_PLAY_FALL
			return
		end
	
	end // end of ghostmoves
	
	local GBoopCollide = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,angle,thrust,thrust2,collisiontype)
		if not (plr[n1])
			return false
		end
		if not (mo[n1])
			return false
		end
		if mo[n1].state == S_PLAY_GCROUCH1 or mo[n1].state == S_PLAY_GCROUCH2 then
			if (mo[n2].z >= mo[n1].z+(mo[n1].height/2)) or // top head collision
			(mo[n2].z <= mo[n1].z-(mo[n1].height/2) and plr[n1].gravityfliped) then 
				local highjumppow = 15
					if (mo[n2].eflags&MFE_UNDERWATER) then
							highjumppow = 8
					end
				plr[n1].crouchcharge = 0
				plr[n1].chargedaction = true
				plr[n1].jumpedaction = true
				mo[n1].state = S_PLAY_GBOOP
				mo[n2].momz = 0
				A_ZThrust(mo[n2], highjumppow, (1<<1)+0)
				mo[n2].state = S_PLAY_SPRING
				mo[n2].eflags = $| MFE_SPRUNG
				plr[n2].pflags = $&~PF_STARTJUMP
				plr[n2].pflags = $&~PF_JUMPED
				S_StartSound(mo[n1], sfx_s3k8a)
			end
		end
		if mo[n1].state == S_PLAY_SCLAW1 then // slow down enemy player durring claw startup
			mo[n2].momx = $/3
			mo[n2].momy = $/3
		end
	end
		
	local function GhostPriority3(player)
		//local mo = player.mo
		if player.mo.state == S_PLAY_GCROUCH1 or player.mo.state == S_PLAY_GCROUCH2 then
			B.SetPriority(player,0,0,"tails_fly",0,3,"ghost boop")
		elseif player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_JUMP then
			B.SetPriority(player,0,1,"knuckles_glide",1,1,"ghost tackle")
		elseif player.mo.state == S_PLAY_SCLAW1 or player.mo.state == S_PLAY_SCLAW2 then
			B.SetPriority(player,1,3,"tails_fly",2,3,"shadow claw")
		elseif player.mo.state == S_PLAY_PSONG or player.mo.state == S_PLAY_DBOND then
			B.SetPriority(player,1,0,nil,1,0,"ghostly swag")
		end
	end

	//exhaust
		local function GhostExhaust(player)
			if player.mo and (player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN)
				local maxtime = 5*TICRATE
				player.exhaustmeter = max(0,$-FRACUNIT/maxtime)
				
				if not player.exhaustmeter
					P_ResetPlayer(player)
					player.mo.state = S_PLAY_FALL
				end
			elseif P_IsObjectOnGround(player.mo)
				player.exhaustmeter = FRACUNIT
			end
			return true
		end

//Stats
	B.SkinVars["hyudoro"] = {
		weight = 65, // 65?
		guard_frame = 1,
		special = GhostTypeMoves,
		func_priority_ext = GhostPriority3,
		func_postcollide = GBoopCollide,
		func_exhaust = GhostExhaust
	}

	print("\x8C\Hyudoro's BattleMod support added!")
end)